From 91a5c297cf77e378eac3dc7527b1bce4871c12b8 Mon Sep 17 00:00:00 2001
From: Mark Reynolds <mreynolds@redhat.com>
Date: Tue, 30 Jun 2020 15:38:39 -0400
Subject: [PATCH] Phase 1 - don't import PF from cockpit

---
 src/cockpit/389-console/package-lock.json     | 2684 ++++++++++++++++-
 src/cockpit/389-console/package.json          |    9 +
 src/cockpit/389-console/src/css/_fonts.scss   |   37 +
 .../src/css/patternfly-4-cockpit.scss         |   16 +
 .../src/css/patternfly-cockpit.scss           |   12 +
 .../css/patternfly-overrides-variables.scss   |   88 +
 .../src/css/patternfly-overrides.scss         |  754 +++++
 src/cockpit/389-console/src/index.es6         |    1 +
 src/cockpit/389-console/src/index.html        |    1 -
 src/cockpit/389-console/webpack.config.js     |  103 +-
 10 files changed, 3549 insertions(+), 156 deletions(-)
 create mode 100644 src/cockpit/389-console/src/css/_fonts.scss
 create mode 100644 src/cockpit/389-console/src/css/patternfly-4-cockpit.scss
 create mode 100644 src/cockpit/389-console/src/css/patternfly-cockpit.scss
 create mode 100644 src/cockpit/389-console/src/css/patternfly-overrides-variables.scss
 create mode 100644 src/cockpit/389-console/src/css/patternfly-overrides.scss

diff --git a/src/cockpit/389-console/src/index.es6 b/src/cockpit/389-console/src/index.es6
index 91abfcf11..1f1d284ba 100644
--- a/src/cockpit/389-console/src/index.es6
+++ b/src/cockpit/389-console/src/index.es6
@@ -1,5 +1,6 @@
 import React from "react";
 import ReactDOM from "react-dom";
+import './css/patternfly-cockpit.scss';
 import { DSInstance } from "./ds.jsx";
 
 document.addEventListener("DOMContentLoaded", function () {
diff --git a/src/cockpit/389-console/webpack.config.js b/src/cockpit/389-console/webpack.config.js
index 0c44247f0..6ff2d98bd 100644
--- a/src/cockpit/389-console/webpack.config.js
+++ b/src/cockpit/389-console/webpack.config.js
@@ -1,6 +1,7 @@
 const path = require("path");
 const copy = require("copy-webpack-plugin");
-const extract = require("extract-text-webpack-plugin");
+const extract = require("mini-css-extract-plugin");
+const OptimizeCSSAssetsPlugin = require('optimize-css-assets-webpack-plugin');
 const fs = require("fs");
 const webpack = require("webpack");
 const CompressionPlugin = require("compression-webpack-plugin");
@@ -143,16 +144,19 @@ module.exports = {
                 loader: "babel-loader",
                 test: /\.es6$/
             },
-            {
+            //{
                 // Transform our own .css files with PostCSS and CSS-modules
-                test: /\.css$/,
-                exclude: /node_modules/,
-                use: ["style-loader", "css-loader"]
-            },
+            //    test: /\.css$/,
+            //    exclude: /node_modules/,
+            //    use: ["style-loader", "css-loader"]
+            //},
             {
-                test: /\.css$/,
-                include: /node_modules/,
-                use: ["style-loader", "css-loader"]
+                test: /\.less$/,
+                use: [
+                    extract.loader,
+                    'css-loader',
+                    'less-loader',
+                ]
             },
             {
                 test: /\.(png|jpg|gif)$/i,
@@ -164,7 +168,86 @@ module.exports = {
                         }
                     }
                 ]
-            }
+            },
+            /* HACK: remove unwanted fonts from PatternFly's css */
+            {
+                test: /patternfly-cockpit.scss$/,
+                use: [
+                    extract.loader,
+                    {
+                        loader: 'css-loader',
+                        options: {
+                            sourceMap: true,
+                            url: false,
+                        },
+                    },
+                    {
+                        loader: 'string-replace-loader',
+                        options: {
+                            multiple: [
+                                {
+                                    search: /src:url[(]"patternfly-icons-fake-path\/glyphicons-halflings-regular[^}]*/g,
+                                    replace: 'font-display:block; src:url("../base1/fonts/glyphicons.woff") format("woff");',
+                                },
+                                {
+                                    search: /src:url[(]"patternfly-fonts-fake-path\/PatternFlyIcons[^}]*/g,
+                                    replace: 'src:url("../base1/fonts/patternfly.woff") format("woff");',
+                                },
+                                {
+                                    search: /src:url[(]"\.\.\/fonts\/fontawesome[^}]*/,
+                                    replace: 'font-display:block; src:url("../base1/fonts/fontawesome.woff?v=4.2.0") format("woff");',
+                                },
+                                {
+                                    search: /src:url\("patternfly-icons-fake-path\/pficon[^}]*/g,
+                                    replace: 'src:url("../base1/fonts/patternfly.woff") format("woff");',
+                                },
+                                {
+                                    search: /@font-face[^}]*patternfly-fonts-fake-path[^}]*}/g,
+                                    replace: '',
+                                },
+                            ]
+                        },
+                    },
+                    {
+                        loader: 'sass-loader',
+                        options: {
+                            sassOptions: {
+                                includePaths: [
+                                    // Teach webpack to resolve these references in order to build PF3 scss
+                                    path.resolve(nodedir, 'font-awesome-sass', 'assets', 'stylesheets'),
+                                    path.resolve(nodedir, 'patternfly', 'dist', 'sass'),
+                                    path.resolve(nodedir, 'bootstrap-sass', 'assets', 'stylesheets'),
+                                ],
+                                outputStyle: 'compressed',
+                            },
+                            sourceMap: true,
+                        },
+                    },
+                ]
+            },
+            {
+                test: /\.s?css$/,
+                exclude: /patternfly-cockpit.scss/,
+                use: [
+                    extract.loader,
+                    {
+                        loader: 'css-loader',
+                        options: {
+                            sourceMap: true,
+                            url: false
+                        }
+                    },
+                    {
+                        loader: 'sass-loader',
+                        options: {
+                            sourceMap: true,
+                            sassOptions: {
+                                outputStyle: 'compressed',
+                            }
+                        }
+                    },
+                ]
+            },
         ]
     },
     plugins: plugins,
-- 
2.26.2

